The Spring Framework

## org.springframework.jmx.support
Class WebLogicMBeanServerFactoryBean

    java.lang.Object
      org.springframework.jmx.support.WebLogicMBeanServerFactoryBean

All Implemented Interfaces:
  FactoryBean, InitializingBean

    public class WebLogicMBeanServerFactoryBean

extends Object
implements FactoryBean, InitializingBean

FactoryBean that obtains a specified WebLogic `MBeanServer` reference through WebLogic's proprietary `Helper` / `MBeanHome` API, which is available on WebLogic 6.1 and higher.

Exposes the `MBeanServer` for bean references. This FactoryBean is a direct alternative to `MBeanServerFactoryBean`, which uses standard JMX 1.2 API to access the platform's MBeanServer.

Note: There is also a `WebLogicJndiMBeanServerFactoryBean` for accessing the WebLogic `MBeanServer` instance through a WebLogic `MBeanHome` obtained via a JNDI lookup, typical a local one.

NOTE: This class is only intended for use with WebLogic up to 8.1. On WebLogic 9.x, simply obtain the MBeanServer directly from the JNDI location "java:comp/env/jmx/runtime", for example through the following configuration:

     <bean class="org.springframework.jndi.JndiObjectFactoryBean">
       <property name="jndiName" value="java:comp/env/jmx/runtime"/>
     </bean>

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  `weblogic.management.Helper#getMBeanHome(String, String, String, String)`, `weblogic.management.MBeanHome#getMBeanServer()`, `MBeanServer`, `MBeanServerFactoryBean`, `WebLogicJndiMBeanServerFactoryBean`

Constructor Summary
`WebLogicMBeanServerFactoryBean()`

Method Summary
`void` `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`Object` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` `isSingleton()` Is the object managed by this factory a singleton?
`void` `setPassword(String password)` Set the password to use for retrieving the WebLogic MBeanServer.
`void` `setServerName(String serverName)` Set the server name to use for retrieving the WebLogic MBeanServer.
`void` `setServerUrl(String serverUrl)` Set the server URL to use for retrieving the WebLogic MBeanServer.
`void` `setUsername(String username)` Set the username to use for retrieving the WebLogic MBeanServer.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### WebLogicMBeanServerFactoryBean

    public WebLogicMBeanServerFactoryBean()

Method Detail

### setUsername

    public void setUsername(String username)

  Set the username to use for retrieving the WebLogic MBeanServer. Default is "weblogic".

### setPassword

    public void setPassword(String password)

  Set the password to use for retrieving the WebLogic MBeanServer. Default is "weblogic".

### setServerUrl

    public void setServerUrl(String serverUrl)

  Set the server URL to use for retrieving the WebLogic MBeanServer. Default is "t3://localhost:7001".

### setServerName

    public void setServerName(String serverName)

  Set the server name to use for retrieving the WebLogic MBeanServer. Default is "server".

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws MBeanServerNotFoundException

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `MBeanServerNotFoundException`

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

The Spring Framework

Copyright © 2002-2008 The Spring Framework.